import matplotlib.pyplot as plt
import matplotlib.font_manager as fm

# ۼ
basePrice, salePrice = 49, 75

# numʱۣԽ࣬Խ
def compute(num):
    return salePrice * (1-0.01*num)

# numbers洢˿͹
# earns洢̳ӯ
# totalConsumption洢˿ܽ
# saves洢˿ͽʡܽ
numbers = list(range(1, 31))
earns = []
totalConsumption = []
saves = []
# ݹ˿͹
for num in numbers:
    earns.append(round(num*(compute(num)-basePrice), 2))
    totalConsumption.append(round(num*compute(num), 2))
    saves.append(round(num*(salePrice-compute(num)), 2))

# ̼ӯ͹˿ͽʡͼϵͳԶɫ
plt.plot(numbers, earns, label='̼ӯ')
plt.plot(numbers, totalConsumption, label='˿', ls='-.')
plt.plot(numbers, saves, label='˿ͽʡ', lw=3)

# ı
plt.xlabel('˿͹', fontproperties='simhei')
plt.ylabel('Ԫ', fontproperties='simhei')
# ͼα
plt.title('-ϵͼ', fontproperties='stkaiti')

# 壬ͼ
myfont = fm.FontProperties(fname=r'C:\Windows\Fonts\STKAITI.ttf')
plt.legend(prop=myfont)

# 㲢̼ӯ
maxEarn = max(earns)
bestNumber = numbers[earns.index(maxEarn)]
# ɢͼӦλûһɫǣ8.3
plt.scatter([bestNumber], [maxEarn], marker='*', color='red', s=120)
# ʹıעǸλ
plt.annotate(xy=(bestNumber, maxEarn),          # ͷյ
             xytext=(bestNumber-1, maxEarn+200),# ͷ
             s=str(maxEarn),                    # ʾıעı
             arrowprops=dict(arrowstyle="->"))  # ͷʽ

# ʾͼ
plt.show()
